<?php
/**
 * 微吼API接口
 * @作者 苏相锟 <admin@phpok.com>
 * @主页 https://www.phpok.com
 * @版本 6.x
 * @授权 GNU Lesser General Public License https://www.phpok.com/lgpl.html 
 * @时间 2022年11月11日
**/

/**
 * 安全限制，防止直接访问
**/
if(!defined("PHPOK_SET")){
	exit("<h1>Access Denied</h1>");
}

class vhall_lib extends _init_lib
{
	private $app_key = '451f4eea5052212beb126611abb5c157';
	private $secret_key = 'adb84d6b5bfee3ef983b8257d42c3fb8';
	private $app_secret_key = 'c5591b3f16f1f379beafa697946f0be0';
	
	private $sign_type = 0;
	private $method = '';
	private $_server = 'https://saas-open.vhall.com';
	private $signed_at = '';
	private $_ip = '';
	
	public function __construct()
	{
		parent::__construct();
		$this->signed_at = $this->time;
	}

	public function ip($value='')
	{
		if($val){
			$this->_ip = $val;
		}
		return $this->_ip;
	}

	public function app_key($val='')
	{
		if($val){
			$this->app_key = $val;
		}
		return $this->app_key;
	}

	public function secret_key($val='')
	{
		if($val != ''){
			$this->secret_key = $val;
		}
		return $this->secret_key;
	}

	public function app_secret_key($val='')
	{
		if($val != ''){
			$this->app_secret_key = $val;
		}
		return $this->app_secret_key;
	}
	
	public function server_url($url='')
	{
		if($url){
			$this->_server = $url;
		}
		return $this->_server;
	}

	/* 
	 * 签名
	 */
	public function sign($data=array())
	{
		$str = '';
		if (!is_array($data)) {
			return false;
		}
		$params = $this->_params();
		foreach($data as $key=>$value){
			$params[$key] = $value;
		}
		ksort($params);
		foreach ($params as $key => $value) {
			if($key == 'sign'){
				continue;
			}
			if($value === '' || is_array($value)){
				$str .= $key;
			}else{
				$str .= $key.$value;
			}
		}
		$str = $this->secret_key . $str . $this->secret_key;
		return md5($str);
	}

	/**
	 * 创建活动标签
	 * @参数 $name 标签昵称，10个字以内
	 * @参数 $user_id 子账号用户id,操作子账号必传
	**/
	public function label_create($name,$user_id=0)
	{
		if(!$name){
			return false;
		}
		$url = '/v3/webinars/label/create';
		$data = array();
		$data['name'] = $name;
		if($user_id){
			$data['user_id'] = $user_id;
		}
		$info = $this->content($url,$data);
		return $info;
	}

	/**
	 * 删除活动标签
	 * @参数 $ids 支持多个批量删除（逗号分割）
	 * @参数 $user_id 子账号用户id,操作子账号必传
	**/
	public function label_delete($ids,$user_id=0)
	{
		if(!$name){
			return false;
		}
		$url = '/v3/webinars/label/delete';
		$data = array();
		$data['label_ids'] = $ids;
		if($user_id){
			$data['user_id'] = $user_id;
		}
		$info = $this->content($url,$data);
		return $info;
	}

	/**
	 * 修改活动标签
	 * @参数 $name 标签昵称，10个字以内
	 * @参数 $id 标签ID，对应 label_id
	 * @参数 $user_id 子账号用户id,操作子账号必传
	**/
	public function label_edit($name,$id=0,$user_id=0)
	{
		if(!$name || !$id){
			return false;
		}
		$url = '/v3/webinars/label/edit';
		$data = array();
		$data['name'] = $name;
		$data['label_id'] = $id;
		if($user_id){
			$data['user_id'] = $user_id;
		}
		$info = $this->content($url,$data);
		return $info;
	}

	/**
	 * 活动标签列表
	 * @参数 $offset 开始位置 默认 0
	 * @参数 $psize 一次查询多少条 最多 100
	 * @参数 $keywords 支持模糊筛选
	 * @参数 $user_id 子账号用户id,操作子账号必传，筛选子账户标签
	 * @返回 json 或 false 请求成功返回 json ，失败返回 false
	**/
	public function label_list($offset=0,$psize=100,$keywords='',$user_id=0)
	{
		$url = '/v3/webinars/label/get-list';
		$data = array();
		$data['pos'] = $offset;
		$data['limit'] = $psize;
		if($user_id){
			$data['user_id'] = $user_id;
		}
		if($keywords){
			$data['name'] = $keywords;
		}
		$info = $this->content($url,$data);
		return $info;
	}

	/**
	 * 置顶活动标签
	 * @参数 $id 标签ID，对应 label_id
	 * @参数 $user_id 子账号用户id,操作子账号必传
	**/
	public function label_reset($user_id=0)
	{
		$url = '/v3/webinars/label/reset-order';
		$data = array();
		if($user_id){
			$data['user_id'] = $user_id;
		}
		$info = $this->content($url,$data);
		return $info;
	}

	/**
	 * 置顶活动标签
	 * @参数 $id 标签ID，对应 label_id
	 * @参数 $user_id 子账号用户id,操作子账号必传
	**/
	public function label_top($id=0,$user_id=0)
	{
		if(!$id){
			return false;
		}
		$url = '/v3/webinars/label/top';
		$data = array();
		$data['label_id'] = $id;
		if($user_id){
			$data['user_id'] = $user_id;
		}
		$info = $this->content($url,$data);
		return $info;
	}
	
	/**
	 * 创建直播间
	 * @参数 $data 数组
	 *           [subject] 活动标题，不超过80字
	 *           [start_time] 直播开始时间
	 *           [webinar_type] 直播模式，1音频直播、2视频视频、3互动直播 、6分组直播。活动一旦创建成功，直播模式将不可修改
	 *           [introduction] 活动简介
	 *           [img_url] 活动封面图，建议尺寸1280*720px，小于4M，支持jpg、gif、png、bmp
	 *           [fee] 金额
	 *           [password] 观看限制密码
	 *           [verify] 观看限制 : 0 无验证，1 密码，2 白名单，3 付费活动, 4 F码 ,6 付费+F码
	 * @返回 json 或 false 请求成功返回 json ，失败返回 false
	**/
	public function live_create($data=array())
	{
		$url = '/v3/webinars/webinar/create';
		$info = $this->content($url,$data);
		return $info;
	}

	/**
	 * 删除直播活动
	 * @参数 $id 活动id字符串，多个逗号分割，注意对应的是 webinar_id
	 * @返回 json 或 false 请求成功返回 json ，失败返回 false
	**/
	public function live_delete($id=0)
	{
		if(!$id){
			return false;
		}
		$url = '/v3/webinars/webinar/delete';
		$data = array();
		$data['webinar_id'] = $id;
		$info = $this->content($url,$data);
		return $info;
	}

	/**
	 * 修改直播活动信息
	 * @参数 $id 活动id，对应 webinar_id
	 * @参数 $data 数组
	 *           [subject] 活动标题，不超过80字
	 *           [start_time] 直播开始时间
	 *           [webinar_type] 直播模式，1音频直播、2视频视频、3互动直播 、6分组直播。活动一旦创建成功，直播模式将不可修改
	 *           [introduction] 活动简介
	 *           [img_url] 活动封面图，建议尺寸1280*720px，小于4M，支持jpg、gif、png、bmp
	 *           [fee] 金额
	 *           [password] 观看限制密码
	 *           [verify] 观看限制 : 0 无验证，1 密码，2 白名单，3 付费活动, 4 F码 ,6 付费+F码
	 * @返回 json 或 false 请求成功返回 json ，失败返回 false
	**/
	public function live_edit($data,$id=0)
	{
		if(!$data || !is_array($data)){
			return false;
		}
		if(!$id && !$data['webinar_id']){
			return false;
		}
		if($id){
			$data['webinar_id'] = $id;
		}
		$url = '/v3/webinars/webinar/edit';
		$info = $this->content($url,$data);
		return $info;
	}

	/**
	 * 直播间详细信息
	 * @参数 $id 活动ID，对应 webinar_id
	 * @返回 json 或 false 请求成功返回 json ，失败返回 false
	**/
	public function live_info($id)
	{
		if(!$id){
			return false;
		}
		$url = '/v3/webinars/webinar/info';
		$data = array();
		$data['webinar_id'] = $id;
		$info = $this->content($url,$data);
		return $info;
	}

	/* 
	 * 获取直播间列表
	 * @参数 $offset 获取条目节点 eg : 10 从第10条开始查询
	 * @参数 $psize 数字,每次返回条数,最大16
	 * @参数 $uids 子账号ID
	 * @参数 $keywords 活动标题或活动ID
	 * @参数 $state 默认为0 可以传入多个值 使用逗号分隔 0 全部 2 预告 1 直播 3 结束 4 点播 5 回放
	 * @返回 json 或 false 请求成功返回 json ，失败返回 false
	 */
	public function live_list($offset=0,$psize=16,$uids='',$keywords='',$state=0)
	{
		$url = '/v3/webinars/webinar/get-list';
		$data = array();
		$data['pos'] = $offset;
		$data['limit'] = $psize;
		if($uids){
			$data['user_id'] = $uids;
		}
		if($keywords){
			$data['title'] = $keywords;
		}
		if($state){
			$data['webinar_state'] = $state;
		}
		$data['get_all'] = 1;
		$info = $this->content($url,$data);
		return $info;
	}

	/**
	 * 创建专题
	 * @参数 $data 数组
	 *           [subject] 专题标题，100个字
	 *           [introduction] 专题简介
	 *           [img_url] 专题封面图，建议尺寸1280*720px，小于4M，支持jpg、gif、png、bmp
	 *           [webinar_ids] 活动id字符串，添加至专题列表
	 *           [subject_verify] 0 免费 1 观看限制 2 报名表单
	 *           [user_id] 子账号用户id,操作子账号必传
	 * @返回 json 或 false 请求成功返回 json ，失败返回 false
	**/
	public function topic_create($data=array())
	{
		$url = '/v3/webinars/subject/create';
		$info = $this->content($url,$data);
		return $info;
	}

	/**
	 * 删除专题
	 * @参数 $ids 支持多个批量删除（逗号分割）
	 * @参数 $user_id 子账号用户id,操作子账号必传
	**/
	public function topic_delete($ids,$user_id=0)
	{
		if(!$name){
			return false;
		}
		$url = '/v3/webinars/subject/delete';
		$data = array();
		$data['subject_ids'] = $ids;
		if($user_id){
			$data['user_id'] = $user_id;
		}
		$info = $this->content($url,$data);
		return $info;
	}

	/**
	 * 创建专题
	 * @参数 $data 数组
	 *           [subject] 专题标题，100个字
	 *           [introduction] 专题简介
	 *           [img_url] 专题封面图，建议尺寸1280*720px，小于4M，支持jpg、gif、png、bmp
	 *           [webinar_ids] 活动id字符串，添加至专题列表
	 *           [subject_verify] 0 免费 1 观看限制 2 报名表单
	 *           [user_id] 子账号用户id,操作子账号必传
	 * @参数 $id 专题ID
	 * @返回 json 或 false 请求成功返回 json ，失败返回 false
	**/
	public function topic_edit($data=array(),$id=0)
	{
		$url = '/v3/webinars/subject/edit';
		if(!isset($data['id']) || !$data['id']){
			$data['id'] = $id;
		}
		$info = $this->content($url,$data);
		return $info;
	}

	/* 
	 * 获取专题列表
	 * @参数 $offset 获取条目节点 eg : 10 从第10条开始查询
	 * @参数 $psize 数字,每次返回条数,最大100
	 * @参数 $order_type 排序规则 1 按照创建时间排序 2 按标题排序
	 * @参数 $keywords 活动标题或活动ID
	 * @参数 $user_id 子账号用户id,操作子账号必传
	 * @参数 $is_private 默认为0 是否隐私 1:是 0:否
	 * @返回 json 或 false 请求成功返回 json ，失败返回 false
	 */
	public function topic_list($offset=0,$psize=100,$order_type=1,$keywords='',$user_id=0,$is_private=0)
	{
		$url = '/v3/webinars/subject/get-list';
		$data = array();
		$data['pos'] = $offset;
		$data['limit'] = $psize;
		$data['order_type'] = 1;
		if($order_type && is_numeric($order_type)){
			$data['order_type'] = $order_type;
		}
		if($keywords){
			$data['title'] = $keywords;
		}
		if($user_id){
			$data['user_id'] = $user_id;
		}
		$data['is_private'] = $is_private;
		$info = $this->content($url,$data);
		return $info;
	}

	/**
	 * 查询专题详情
	 * @参数 $id 专题ID，对应 subject_id
	 * @返回 json 或 false 请求成功返回 json ，失败返回 false
	**/
	public function topic_info($id)
	{
		if(!$id){
			return false;
		}
		$url = '/v3/webinars/subject/info';
		$data = array();
		$data['subject_id'] = $id;
		$info = $this->content($url,$data);
		return $info;
	}
	

	/**
	 * 获取子账号列表
	 * @参数 $offset 获取条目节点 eg : 10 从第10条开始查询
	 * @参数 $psize 每次返回条数,最大500
	 * @返回 json 或 false 请求成功返回 json ，失败返回 false
	**/
	public function user_list($offset=0,$psize=500)
	{
		$url = '/v3/users/child/get-list';
		$data = array();
		$data['pos'] = $offset;
		$data['limit'] = $psize;
		$info = $this->content($url,$data);
		return $info;
	}

	/**
	 * 获取子账号列表
	 * @参数 $id 子账号ID
	 * @返回 json 或 false 请求成功返回 json ，失败返回 false
	**/
	public function user_info($id)
	{
		if(!$id){
			return false;
		}
		$url = '/v3/users/child/get-info';
		$data = array();
		$data['child_id'] = $id;
		$info = $this->content($url,$data);
		return $info;
	}

	/**
	 * 修改子账号信息
	 * @参数 $id 子账号id，对应 子账号id
	 * @参数 $data 数组
	 *           [nick_name] 昵称（子帐号昵称的设置，不输入默认同账号ID相同，30字符以内）
	 *           [password] 密码(30字符以内)
	 *           [role_id] 角色id
	 *           [phone] 重置手机号
	 *           [email] 重置邮箱
	 * @返回 json 或 false 请求成功返回 json ，失败返回 false
	**/
	public function user_edit($data,$id=0)
	{
		if(!$data || !is_array($data)){
			return false;
		}
		if(!$id && !$data['webinar_id']){
			return false;
		}
		if($id){
			$data['webinar_id'] = $id;
		}
		$url = '/v3/users/child/edit';
		$info = $this->content($url,$data);
		return $info;
	}
	
	/**
	 * 获取内容
	 * @参数 $url 访问地址，自动补全接口网址
	 * @参数 $data 数组
	 * @返回 json 或 false 请求成功返回 json ，失败返回 false
	**/
	public function content($url="",$data=array())
	{
		$params = $this->_params();
		$params['sign'] = $this->sign($data);
		foreach($data as $key=>$value){
			$params[$key] = $value;
		}
		if(substr($url,0,7) != 'http://' || substr($url,0,8) != 'https://'){
			$url = $this->_server.$url;
		}
		$info = $this->_curl($url,$params);
		if(!$info){
			return false;
		}
		$info = trim($info);
		if(substr($info,0,1) != '{'){
			return $info;
		}
		$info = $this->lib('json')->decode($info,true);
		if(!$info['code']){
			return $info;
		}
		if($info['code'] != 200){
			$data = array();
			$data['info'] = 'Error ID：'.$info['code'].', Error Info:'.$info['msg'];
			$data['status'] = false;
			return $data; 
		}
		$data = array();
		$data['status'] = true;
		$data['info'] = $info['data'];
		return $data;
	}

	private function _params()
	{
		$params = array();
		$params['app_key'] = $this->app_key;
		$params['sign_type'] = 0;
		$params['signed_at'] = $this->time;
		return $params;
	}

	private function _curl($url,$data)
	{
		$curl = curl_init();
		curl_setopt($curl, CURLOPT_FORBID_REUSE, true);
		curl_setopt($curl, CURLOPT_HEADER,true);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($curl,CURLOPT_POST,true);
		$post = http_build_query($data);
		curl_setopt($curl,CURLOPT_POSTFIELDS,$post);
		$headers = array();
		$headers[] = 'Content-length: '.strlen($post);
		curl_setopt($curl, CURLOPT_CONNECTTIMEOUT,15);//等待时间，超时退出
		curl_setopt($curl,CURLOPT_ENCODING ,'gzip');//GZIP压缩
		curl_setopt($curl,CURLOPT_USERAGENT,$_SERVER['HTTP_USER_AGENT']);
		$info = parse_url($url);
		if($this->_ip){
			$port = $info['port'] ? $info['port'] : ($info['scheme'] == 'https' ? '443' : '80');
			$headers[] = "Host: ".$info['host'].':'.$port;
			if($info['scheme'] == 'http'){
				$string = $info['scheme'].'://'.$info['host'];
				$url = $info['scheme'].'://'.$this->_ip.substr($url,strlen($string));
			}
		}
		$headers[] = 'Expect: ';
		curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
		curl_setopt($curl, CURLOPT_URL, $url);
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
		curl_setopt($curl, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
		$content = curl_exec($curl);
		if (curl_errno($curl) != 0){
			return false;
		}
		$separator = '/\r\n\r\n|\n\n|\r\r/';
		list($head, $body) = preg_split($separator, $content, 2);
		if($body){
			$body = $this->_bom($body);
		}
		$code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
		curl_close($curl);
		if($code == 301 || $code == 302){
			$matches = array();
			preg_match('/Location:(.*?)\n/', $head, $matches);
			$url = @parse_url(trim(array_pop($matches)));
			if (!$url){
				return false;
			}
			$new_url = $url['scheme'] . '://' . $url['host'] . $url['path']
			. (isset($url['query']) ? '?' . $url['query'] : '');
			$new_url = stripslashes($new_url);
			$this->server_url($new_url);
			return $this->_curl($new_url,$data);
		}
		if($code != '200'){
			return false;
		}
		return $body;
	}

	private function _bom($info)
	{
		$info = trim($info);
		$a1 = substr($info, 0, 1);
		$a2 = substr($info, 1, 1);
		$a3 = substr($info, 2, 1);
		if(ord($a1) == 239 && ord($a2) == 187 && ord($a3) == 191){
			return substr($info,3);
		}
		return $info;
	}
}
